package edu.sjsu.rhinofaces;

import java.util.logging.Logger;

import javax.faces.FacesException;
import javax.faces.application.Application;
import javax.faces.application.NavigationHandler;
import javax.faces.component.ActionSource;
import javax.faces.context.FacesContext;
import javax.faces.el.MethodBinding;
import javax.faces.event.ActionEvent;
import javax.faces.event.ActionListener;

/**
   This should probably be tossed and replaced with a totally different
   approach. This calls JS commands by catching exceptions.
   
   Ugly, ugly, ugly. But it works for now.
   
   @author Tom Austin
 */
public class RhinoActionListener implements ActionListener
{
   private static Logger logger = Logger.global;
   
   private ActionListener delegate;
   /**
      Constructor.
    * @param listener 
    */
   public RhinoActionListener(ActionListener delegate)
   {
      this.delegate = delegate;
      logger.info("Initialized RhinoActionListener");
   }

   /**
      Calls the processAction of the parent class and catches exceptions thrown
      for missing methods.  From these, it determines what JS command to execute
    */
   public void processAction(ActionEvent event)
   {
      try
      {
         delegate.processAction(event);
      }
      catch (FacesException e)
      {
         Throwable t = e.getCause();
         String command = t.getMessage().replaceFirst(".*:", "");

         FacesContext context = FacesContext.getCurrentInstance();
         Application application = context.getApplication();
         
         JavaScriptEnvironment jse = ((RhinoApplication)application).getJavaScriptEnvironment(context.getELContext());
         command = command.replaceFirst("edu.sjsu.rhinofaces.JSVar@.*\\.", jse.getLastVariableCalled().getName() + ".");
         Object result = jse.evalRhino(command);

         String outcome = null;
         if (result != null && result != org.mozilla.javascript.Undefined.instance)
         {
            outcome = "" + result;
         }

         logger.info("Outcome is " + outcome);

         NavigationHandler navHandler = application.getNavigationHandler();
         MethodBinding binding = ((ActionSource) event.getComponent()).getAction();

         String exprStr = (null != binding) ? binding.getExpressionString() : null;
         logger.info("ExpressionString: " + exprStr);
         navHandler.handleNavigation(context, exprStr, outcome);
      }
   }
}
